libzypp: zypp::target::SolvIdentFile Class Reference

libzypp 17.38.10

zypp::target::SolvIdentFile Class Reference

Save and restore a list of solvable names (ident IdString). More...

`#include <zypp/target/SolvIdentFile.h>`

## Public Types
using | Data = std::unordered_set<IdString>

## Public Member Functions
| SolvIdentFile (Pathname file_r)
| Ctor taking the file to read/write.
const Pathname & | file () const
| Return the file path.
const Data & | data () const
| Return the data.
void | setData (const Data &data_r)
| Store new Data.

## Private Member Functions
bool | differs (const Data &lhs, const Data &rhs) const
| Helper testing whether two Data differ.

## Static Private Member Functions
static void | load (const Pathname &file_r, Data &data_r)
| Read Data from `file_r`.
static void | store (const Pathname &file_r, const Data &data_r)
| Write Data to `file_r`.

## Private Attributes
Pathname | _file
scoped_ptr< Data > | _dataPtr

## Friends
std::ostream & | operator<< (std::ostream &str, const SolvIdentFile &obj)
| relates: SolvIdentFile Stream output

## Detailed Description

Save and restore a list of solvable names (ident IdString).

Definition at line 34 of file SolvIdentFile.h.

## Member Typedef Documentation

## ◆ Data

using zypp::target::SolvIdentFile::Data = std::unordered_set<IdString>

Definition at line 38 of file SolvIdentFile.h.

## Constructor & Destructor Documentation

## ◆ SolvIdentFile()

zypp::target::SolvIdentFile::SolvIdentFile | ( | Pathname | file_r | ) |
| inline

Ctor taking the file to read/write.

Definition at line 42 of file SolvIdentFile.h.

## Member Function Documentation

## ◆ file()

const Pathname & zypp::target::SolvIdentFile::file | ( |  | ) | const
| inline

Return the file path.

Definition at line 47 of file SolvIdentFile.h.

## ◆ data()

const Data & zypp::target::SolvIdentFile::data | ( |  | ) | const
| inline

Return the data.

The file is read once on demand. Returns empty Data if the file does not exist or is not readable.

Definition at line 54 of file SolvIdentFile.h.

## ◆ setData()

void zypp::target::SolvIdentFile::setData | ( | const Data & | data_r | ) |
| inline

Store new Data.

Write the new Data to file, unless we know it did not change. The directory containing file must exist.

Definition at line 70 of file SolvIdentFile.h.

## ◆ differs()

bool zypp::target::SolvIdentFile::differs | ( | const Data & | lhs,
|  | const Data & | rhs ) const
| inlineprivate

Helper testing whether two Data differ.

Definition at line 84 of file SolvIdentFile.h.

## ◆ load()

void zypp::target::SolvIdentFile::load | ( | const Pathname & | file_r,
|  | Data & | data_r )
| staticprivate

Read Data from `file_r`.

Definition at line 34 of file SolvIdentFile.cc.

## ◆ store()

void zypp::target::SolvIdentFile::store | ( | const Pathname & | file_r,
|  | const Data & | data_r )
| staticprivate

Write Data to `file_r`.

Definition at line 54 of file SolvIdentFile.cc.

## Friends And Related Symbol Documentation

## ◆ operator<<

std::ostream & operator<< | ( | std::ostream & | str,
|  | const SolvIdentFile & | obj )
| friend

relates: SolvIdentFile Stream output

Definition at line 88 of file SolvIdentFile.cc.

## Member Data Documentation

## ◆ _file

Pathname zypp::target::SolvIdentFile::_file
| private

Definition at line 102 of file SolvIdentFile.h.

## ◆ _dataPtr

scoped_ptr<Data> zypp::target::SolvIdentFile::_dataPtr
| mutableprivate

Definition at line 103 of file SolvIdentFile.h.

The documentation for this class was generated from the following files:

- zypp/target/SolvIdentFile.h
- zypp/target/SolvIdentFile.cc